%
% ci001_hessp.m
%
% This MATLAB function computes the derivatives of the vector field
% defined in ci001_vf.m.
%
% hessp_(n,i,j) is the second partial derivative of the n-th component
% of the vector field, taken with respect to the i-th variable
% and the j-th parameter.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 23-Feb-2009 at 16:56
%
%
function hessp_ = ci001_hessp(t,x_,p_)
    S_         = x_(1);
    P_         = x_(2);
    E_         = x_(3);
    I_         = x_(4);
    k_M_       = p_(1);
    k_I_       = p_(2);
    v_C_       = p_(3);

    hessp_ = zeros(4,4,3);

    hessp_(1,1,1) = E_*(1+I_*k_I_^(-1))*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_-2*E_*(1+I_*k_I_^(-1))*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;
    hessp_(1,1,2) = 2*E_*k_M_*I_*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-E_*k_M_*I_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(1,1,3) = -E_*((1+I_*k_I_^(-1))*k_M_+S_)^(-1)+E_*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2);
    hessp_(1,3,1) = (1+I_*k_I_^(-1))*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(1,3,2) = -k_M_*I_*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(1,3,3) = -S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-1);
    hessp_(1,4,1) = -2*E_*(1+I_*k_I_^(-1))*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+E_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(1,4,2) = 2*E_*k_M_^2*I_*S_*k_I_^(-3)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-E_*k_M_*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(1,4,3) = E_*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2);

    hessp_(2,1,1) = -E_*(1+I_*k_I_^(-1))*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_+2*E_*(1+I_*k_I_^(-1))*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;
    hessp_(2,1,2) = -2*E_*k_M_*I_*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+E_*k_M_*I_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(2,1,3) = E_*((1+I_*k_I_^(-1))*k_M_+S_)^(-1)-E_*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2);
    hessp_(2,3,1) = -(1+I_*k_I_^(-1))*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(2,3,2) = k_M_*I_*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(2,3,3) = S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-1);
    hessp_(2,4,1) = 2*E_*(1+I_*k_I_^(-1))*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-E_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(2,4,2) = -2*E_*k_M_^2*I_*S_*k_I_^(-3)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+E_*k_M_*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hessp_(2,4,3) = -E_*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2);



