%
% cyclin_oscillations001_der3.m
%
% This MATLAB function computes the third derivatives of the vector field
% defined in cyclin_oscillations001_vf.m.
%
% der3_(n,i,j,k) is the third partial derivative of the n-th component
% of the vector field, taken with respect to the i-th, j-th and k-th variables.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 13-Jan-2009 at 16:42
%
%
function der3_ = cyclin_oscillations001_der3(t,x_,p_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);
    k1_        = p_(1);
    k2_        = p_(2);
    k3_        = p_(3);
    k4_        = p_(4);
    vm1_       = p_(5);
    v2_        = p_(6);
    vm3_       = p_(7);
    v4_        = p_(8);
    vi_        = p_(9);
    vd_        = p_(10);
    kc_        = p_(11);
    kD_        = p_(12);
    kd_        = p_(13);

    der3_ = zeros(6,6,6,6);

    der3_(1,1,1,1) = 6*C_*X_ac_*(C_+kD_)^(-4)*vd_-6*X_ac_*(C_+kD_)^(-3)*vd_;
    der3_(1,1,1,5) = -2*C_*(C_+kD_)^(-3)*vd_+2*(C_+kD_)^(-2)*vd_;
    der3_(1,1,5,1) = der3_(1,1,1,5);
    der3_(1,5,1,1) = der3_(1,1,1,5);

    der3_(2,1,1,1) = -6*vm1_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-3)+6*vm1_*C_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-4);
    der3_(2,1,1,2) = -2*vm1_*C_*(k1_+M_in_)^(-1)*(kc_+C_)^(-3)+2*vm1_*C_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-3)+2*vm1_*(k1_+M_in_)^(-1)*(kc_+C_)^(-2)-2*vm1_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-2);
    der3_(2,1,2,1) = der3_(2,1,1,2);
    der3_(2,2,1,1) = der3_(2,1,1,2);
    der3_(2,1,2,2) = -2*vm1_*C_*(k1_+M_in_)^(-2)*(kc_+C_)^(-2)+2*vm1_*(k1_+M_in_)^(-2)*(kc_+C_)^(-1)+2*vm1_*C_*(k1_+M_in_)^(-3)*M_in_*(kc_+C_)^(-2)-2*vm1_*(k1_+M_in_)^(-3)*M_in_*(kc_+C_)^(-1);
    der3_(2,2,2,1) = der3_(2,1,2,2);
    der3_(2,2,1,2) = der3_(2,1,2,2);
    der3_(2,2,2,2) = -6*vm1_*C_*(k1_+M_in_)^(-3)*(kc_+C_)^(-1)+6*vm1_*C_*(k1_+M_in_)^(-4)*M_in_*(kc_+C_)^(-1);
    der3_(2,3,3,3) = -6*M_ac_*(M_ac_+k2_)^(-4)*v2_+6*(M_ac_+k2_)^(-3)*v2_;

    der3_(3,1,1,1) = 6*vm1_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-3)-6*vm1_*C_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-4);
    der3_(3,1,1,2) = 2*vm1_*C_*(k1_+M_in_)^(-1)*(kc_+C_)^(-3)-2*vm1_*C_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-3)-2*vm1_*(k1_+M_in_)^(-1)*(kc_+C_)^(-2)+2*vm1_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-2);
    der3_(3,1,2,1) = der3_(3,1,1,2);
    der3_(3,2,1,1) = der3_(3,1,1,2);
    der3_(3,1,2,2) = 2*vm1_*C_*(k1_+M_in_)^(-2)*(kc_+C_)^(-2)-2*vm1_*(k1_+M_in_)^(-2)*(kc_+C_)^(-1)-2*vm1_*C_*(k1_+M_in_)^(-3)*M_in_*(kc_+C_)^(-2)+2*vm1_*(k1_+M_in_)^(-3)*M_in_*(kc_+C_)^(-1);
    der3_(3,2,2,1) = der3_(3,1,2,2);
    der3_(3,2,1,2) = der3_(3,1,2,2);
    der3_(3,2,2,2) = 6*vm1_*C_*(k1_+M_in_)^(-3)*(kc_+C_)^(-1)-6*vm1_*C_*(k1_+M_in_)^(-4)*M_in_*(kc_+C_)^(-1);
    der3_(3,3,3,3) = 6*M_ac_*(M_ac_+k2_)^(-4)*v2_-6*(M_ac_+k2_)^(-3)*v2_;

    der3_(4,3,4,4) = -2*vm3_*X_in_*(X_in_+k3_)^(-3)+2*vm3_*(X_in_+k3_)^(-2);
    der3_(4,4,4,3) = der3_(4,3,4,4);
    der3_(4,4,3,4) = der3_(4,3,4,4);
    der3_(4,4,4,4) = 6*vm3_*M_ac_*X_in_*(X_in_+k3_)^(-4)-6*vm3_*M_ac_*(X_in_+k3_)^(-3);
    der3_(4,5,5,5) = -6*v4_*X_ac_*(k4_+X_ac_)^(-4)+6*v4_*(k4_+X_ac_)^(-3);

    der3_(5,3,4,4) = 2*vm3_*X_in_*(X_in_+k3_)^(-3)-2*vm3_*(X_in_+k3_)^(-2);
    der3_(5,4,4,3) = der3_(5,3,4,4);
    der3_(5,4,3,4) = der3_(5,3,4,4);
    der3_(5,4,4,4) = -6*vm3_*M_ac_*X_in_*(X_in_+k3_)^(-4)+6*vm3_*M_ac_*(X_in_+k3_)^(-3);
    der3_(5,5,5,5) = 6*v4_*X_ac_*(k4_+X_ac_)^(-4)-6*v4_*(k4_+X_ac_)^(-3);


