%
% mm003_hess.m
%
% This MATLAB function computes the Hessians of the vector field
% defined in mm003_vf.m.
%
% hess_(n,i,j) is the second partial derivative of the n-th component
% of the vector field, taken with respect to the i-th and j-th variables.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 24-Apr-2009 at 14:39
%
%
function hess_ = mm003_hess(t,x_,p_)
    E_         = x_(1);
    S_         = x_(2);
    E_colon_S_ = x_(3);
    P_         = x_(4);
    k1_        = p_(1);
    km1_       = p_(2);
    k2_        = p_(3);

    hess_ = zeros(4,4,4);

    hess_(1,1,2) = -k1_;
    hess_(1,2,1) = hess_(1,1,2);

    hess_(2,1,2) = -k1_;
    hess_(2,2,1) = hess_(2,1,2);

    hess_(3,1,2) = k1_;
    hess_(3,2,1) = hess_(3,1,2);


