%
% sirr001_hess.m
%
% This MATLAB function computes the Hessians of the vector field
% defined in sirr001_vf.m.
%
% hess_(n,i,j) is the second partial derivative of the n-th component
% of the vector field, taken with respect to the i-th and j-th variables.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 23-Feb-2009 at 09:40
%
%
function hess_ = sirr001_hess(t,x_,p_)
    S_         = x_(1);
    I_         = x_(2);
    R_         = x_(3);
    k1_        = p_(1);
    k2_        = p_(2);
    k3_        = p_(3);

    hess_ = zeros(3,3,3);

    hess_(1,1,2) = -k1_;
    hess_(1,2,1) = hess_(1,1,2);

    hess_(2,1,2) = k1_;
    hess_(2,2,1) = hess_(2,1,2);


