/*
 *  mm002_cv.c
 *
 *  CVODE C file for the vector field named: mm002
 *
 *  This file was generated by the program VFGEN (Version:2.4.0)
 *  Generated on 24-Apr-2009 at 14:39
 */

#include <math.h>
/* Include headers for SUNDIALS v2.3.0, CVODE v2.5.0 */
#include <sundials/sundials_types.h>
#include <sundials/sundials_dense.h>
#include <sundials/sundials_nvector.h>
#include <nvector/nvector_serial.h>
#include <cvode/cvode.h>
#include <cvode/cvode_dense.h>
/*
 *  The vector field.
 */

int mm002_vf(realtype t, N_Vector y_, N_Vector f_, void *params)
    {
    realtype E_, S_, E_colon_S_, P_;
    realtype k1_, km1_, k2_;
    realtype r1_, rm1_, r2_;
    realtype *p_;

    p_ = (realtype *) params;

    E_         = NV_Ith_S(y_,0);
    S_         = NV_Ith_S(y_,1);
    E_colon_S_ = NV_Ith_S(y_,2);
    P_         = NV_Ith_S(y_,3);

    k1_        = p_[0];
    km1_       = p_[1];
    k2_        = p_[2];

    r1_ = k1_*E_*S_;
    rm1_ = E_colon_S_*km1_;
    r2_ = E_colon_S_*k2_;

    NV_Ith_S(f_,0) =  r2_-r1_+rm1_;
    NV_Ith_S(f_,1) = -r1_+rm1_;
    NV_Ith_S(f_,2) = -r2_+r1_-rm1_;
    NV_Ith_S(f_,3) = r2_;
    return 0;
    }

/*
 *  The Jacobian.
 */

int mm002_jac(long int N_, DenseMat jac_, realtype t,
                N_Vector y_, N_Vector fy_, void *params,
                N_Vector tmp1, N_Vector tmp2, N_Vector tmp3)
    {
    realtype E_, S_, E_colon_S_, P_;
    realtype k1_, km1_, k2_;
    realtype *p_;

    p_ = (realtype *) params;

    E_         = NV_Ith_S(y_,0);
    S_         = NV_Ith_S(y_,1);
    E_colon_S_ = NV_Ith_S(y_,2);
    P_         = NV_Ith_S(y_,3);

    k1_        = p_[0];
    km1_       = p_[1];
    k2_        = p_[2];

    DENSE_ELEM(jac_, 0, 0) = -k1_*S_;
    DENSE_ELEM(jac_, 0, 1) = -k1_*E_;
    DENSE_ELEM(jac_, 0, 2) =  km1_+k2_;
    DENSE_ELEM(jac_, 1, 0) = -k1_*S_;
    DENSE_ELEM(jac_, 1, 1) = -k1_*E_;
    DENSE_ELEM(jac_, 1, 2) = km1_;
    DENSE_ELEM(jac_, 2, 0) = k1_*S_;
    DENSE_ELEM(jac_, 2, 1) = k1_*E_;
    DENSE_ELEM(jac_, 2, 2) = -km1_-k2_;
    DENSE_ELEM(jac_, 3, 2) = k2_;
    return 0;
    }
