/*
 *  rnaModel001_cvdemo.c
 *
 *
 *  CVODE ODE solver for the vector field named: rnaModel001
 *
 *  This file was generated by the program VFGEN (Version:2.4.0)
 *  Generated on  9-Dec-2008 at 09:52
 *
 */

#include <stdlib.h>
#include <string.h>
#include <math.h>
/* Include headers for SUNDIALS v2.3.0, CVODE v2.5.0 */
#include <sundials/sundials_types.h>
#include <sundials/sundials_dense.h>
#include <sundials/sundials_nvector.h>
#include <nvector/nvector_serial.h>
#include <cvode/cvode.h>
#include <cvode/cvode_dense.h>

#include "rnaModel001_cv.h"


int use(int argc, char *argv[], int nv, char *vname[], double y_[], int np, char *pname[], const double p_[])
    {
    int i;
    printf("use: %s [options]\n",argv[0]);
    printf("options:\n");
    printf("    -h    Print this help message.\n");
    for (i = 0; i < nv; ++i)
        printf("    %s=<initial_condition>   Default value is %e\n",vname[i],y_[i]);
    for (i = 0; i < np; ++i)
        printf("    %s=<parameter_value>   Default value is %e\n",pname[i],p_[i]);
    printf("    abserr=<absolute_error_tolerance>\n");
    printf("    relerr=<relative_error_tolerance>\n");
    printf("    stoptime=<stop_time>\n");
    return 0;
    }


int assign(char *str[], int ns, double v[], char *a)
    {
    int i;
    char name[256];
    char *e;

    e = strchr(a,'=');
    if (e == NULL)
        return(-1);
    *e = '\0';
    strcpy(name,a);
    *e = '=';
    ++e;
    for (i = 0; i < ns; ++i)
        if (strcmp(str[i],name)==0)
            break;
    if (i == ns)
        return(-1);
    v[i] = atof(e);
    return(i);
    }


int main (int argc, char *argv[])
    {
    int i,j;
    int flag;
    const int N_ = 108;
    const int P_ = 11;
    const realtype def_p_[11] = {RCONST(2.0000000000000000e-02), RCONST(2.5000000000000000e-01), RCONST(1.0000000000000000e-02), RCONST(2.9999999999999999e-02), RCONST(1.4999999999999999e-01), RCONST(1.0000000000000000e-02), RCONST(2.5000000000000000e-01), RCONST(2.0000000000000000e-02), RCONST(0.0), RCONST(6.9999999999999996e-01), RCONST(2.9999999999999999e-01)};
    const realtype r7_        = def_p_[0];
    const realtype r4_        = def_p_[1];
    const realtype r5_        = def_p_[2];
    const realtype r6_        = def_p_[3];
    const realtype r3_        = def_p_[4];
    const realtype r8_        = def_p_[5];
    const realtype rt_        = def_p_[6];
    const realtype delay_     = def_p_[7];
    const realtype d_         = def_p_[8];
    const realtype p1_        = def_p_[9];
    const realtype p2_        = def_p_[10];
    realtype def_y_[108] = {RCONST(70.0), RCONST(30.0), RCONST(30.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0), RCONST(0.0)};
    realtype y_[108];
    realtype p_[11];
    realtype solver_param_[3] = {RCONST(1.0e-6),RCONST(0.0),RCONST(10.0)};
    char *varnames_[108] = {"DNAl1init_", "DNAp27SAl1init_", "DNACOTCl1Init_", "El35Sl1_", "El27SBl1_", "El27SA2l1_", "El23Su_", "El23Sl1_", "El23Sl2_", "El23Sl3_", "El23Sl4_", "El23Sl5_", "El23Sl6_", "El20Su_", "El18Su_", "El20Sl1_", "El20Sl2_", "El20Sl3_", "El20Sl4_", "El20Sl5_", "El20Sl6_", "El35Sl2_", "El27SBl2_", "El27SA2l2_", "El35Sl3_", "El27SBl3_", "El27SA2l3_", "El35Sl4_", "El27SBl4_", "El27SA2l4_", "El35Sl5_", "El27SBl5_", "El27SA2l5_", "El35Sl6_", "El27SBl6_", "El27SA2l6_", "El35Sl7_", "El27SBl7_", "El27SA2l7_", "El35Sl8_", "El27SBl8_", "El27SA2l8_", "El35Sl9_", "El27SBl9_", "El27SA2l9_", "El35Sl10_", "El27SBl10_", "El27SA2l10_", "El35Sl11_", "El35Sl12_", "El35Sl13_", "El35Sl14_", "El35Sl15_", "El35Sl16_", "El35Sl17_", "El18Sl1_", "El18Sl2_", "El18Sl3_", "El18Sl4_", "El18Sl5_", "El18Sl6_", "ElS7Su_", "ElS7Sl1_", "El25Sl1_", "El25Sl2_", "El25Sl3_", "El25Sl4_", "El25Sl5_", "El25Sl6_", "El25Sl7_", "El25Sl8_", "El25Sl9_", "ElS58Su_", "ElS58Sl1_", "DNAl1_", "DNAl2_", "DNAl3_", "DNAl4_", "DNAl5_", "DNAl6_", "DNAl7_", "DNAl8_", "DNAl9_", "DNAl10_", "DNAl11_", "DNAl12_", "DNAl13_", "DNAl14_", "DNAl15_", "DNAl16_", "DNAl17_", "DNAp27SAl1_", "DNAp27SAl2_", "DNAp27SAl3_", "DNAp27SAl4_", "DNAp27SAl5_", "DNAp27SAl6_", "DNAp27SAl7_", "DNAp27SAl8_", "DNAp27SAl9_", "DNAp27SAl10_", "DNACOTCl1_", "DNACOTCl2_", "DNACOTCl3_", "DNACOTCl4_", "DNACOTCl5_", "DNACOTCl6_", "DNACOTCl7_"};
    char *parnames_[11] = {"r7_", "r4_", "r5_", "r6_", "r3_", "r8_", "rt_", "delay_", "d_", "p1_", "p2_"};
    char *solver_param_names_[3] = {"abserr","relerr","stoptime"};

    for (i = 0; i < N_; ++i)
        y_[i] = def_y_[i];
    for (i = 0; i < P_; ++i)
        p_[i] = def_p_[i];
    for (i = 1; i < argc; ++i)
        {
        int j;
        if (strcmp(argv[i],"-h") == 0)
            {
            use(argc,argv,N_,varnames_,def_y_,P_,parnames_,def_p_);
            exit(0);
            }
        j = assign(varnames_,N_,y_,argv[i]);
        if (j == -1)
            {
            j = assign(parnames_,P_,p_,argv[i]);
            if (j == -1)
                {
                j = assign(solver_param_names_,3,solver_param_,argv[i]);
                if (j == -1)
                    {
                    fprintf(stderr,"unknown argument: %s\n",argv[i]);
                    use(argc,argv,N_,varnames_,def_y_,P_,parnames_,def_p_); 
                    exit(-1);
                    }
                }
            }
        }

    N_Vector y0_;
    y0_ = N_VNew_Serial(N_);
    for (i = 0; i < N_; ++i)
        NV_Ith_S(y0_,i) = y_[i];

    /* For non-stiff problems:   */
    void *cvode_mem = CVodeCreate(CV_ADAMS,CV_FUNCTIONAL);
    /* For stiff problems:       */
    /* void *cvode_mem = CVodeCreate(CV_BDF,CV_NEWTON); */

    realtype t = RCONST(0.0);
    flag = CVodeMalloc(cvode_mem,rnaModel001_vf,t,y0_,CV_SS,solver_param_[1],&(solver_param_[0]));
    flag = CVodeSetFdata(cvode_mem,&(p_[0]));
    flag = CVDense(cvode_mem,N_);
    flag = CVDenseSetJacFn(cvode_mem,rnaModel001_jac,&(p_[0]));

    realtype t1 = solver_param_[2];
    /* Print the initial condition  */
    printf("%.8e",t);
    for (j = 0; j < N_; ++j)
        printf(" %.8e",NV_Ith_S(y0_,j));
    printf("\n");
    flag = CVodeSetStopTime(cvode_mem,t1);
    while (t < t1)
        {
        /* Advance the solution */
        flag = CVode(cvode_mem,t1,y0_,&t,CV_ONE_STEP_TSTOP);
        if (flag != CV_SUCCESS && flag != CV_TSTOP_RETURN)
            {
            fprintf(stderr,"flag=%d\n",flag);
            break;
            }
        /* Print the solution at the current time */
        printf("%.8e",t);
        for (j = 0; j < N_; ++j)
            printf(" %.8e",NV_Ith_S(y0_,j));
        printf("\n");
        }

    N_VDestroy_Serial(y0_);
    CVodeFree(&cvode_mem);
    }
