/*
 *  sirc001_cv.c
 *
 *  CVODE C file for the vector field named: sirc001
 *
 *  This file was generated by the program VFGEN (Version:2.4.0)
 *  Generated on 23-Feb-2009 at 09:50
 */

#include <math.h>
/* Include headers for SUNDIALS v2.3.0, CVODE v2.5.0 */
#include <sundials/sundials_types.h>
#include <sundials/sundials_dense.h>
#include <sundials/sundials_nvector.h>
#include <nvector/nvector_serial.h>
#include <cvode/cvode.h>
#include <cvode/cvode_dense.h>
/*
 *  The vector field.
 */

int sirc001_vf(realtype t, N_Vector y_, N_Vector f_, void *params)
    {
    realtype S_, I_, R_, C_;
    realtype k1_, k2_, k3_, k4_, k5_;
    realtype expose_, develop_, infect_, recover_, relapse_;
    realtype *p_;

    p_ = (realtype *) params;

    S_         = NV_Ith_S(y_,0);
    I_         = NV_Ith_S(y_,1);
    R_         = NV_Ith_S(y_,2);
    C_         = NV_Ith_S(y_,3);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];
    k4_        = p_[3];
    k5_        = p_[4];

    expose_ = S_*k1_;
    develop_ = k2_*C_;
    infect_ = S_*I_*k3_;
    recover_ = k4_*I_;
    relapse_ = k5_*R_;

    NV_Ith_S(f_,0) = -expose_+relapse_-infect_;
    NV_Ith_S(f_,1) = -recover_+develop_+infect_;
    NV_Ith_S(f_,2) =  recover_-relapse_;
    NV_Ith_S(f_,3) =  expose_-develop_;
    return 0;
    }

/*
 *  The Jacobian.
 */

int sirc001_jac(long int N_, DenseMat jac_, realtype t,
                N_Vector y_, N_Vector fy_, void *params,
                N_Vector tmp1, N_Vector tmp2, N_Vector tmp3)
    {
    realtype S_, I_, R_, C_;
    realtype k1_, k2_, k3_, k4_, k5_;
    realtype *p_;

    p_ = (realtype *) params;

    S_         = NV_Ith_S(y_,0);
    I_         = NV_Ith_S(y_,1);
    R_         = NV_Ith_S(y_,2);
    C_         = NV_Ith_S(y_,3);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];
    k4_        = p_[3];
    k5_        = p_[4];

    DENSE_ELEM(jac_, 0, 0) = -k1_-I_*k3_;
    DENSE_ELEM(jac_, 0, 1) = -S_*k3_;
    DENSE_ELEM(jac_, 0, 2) = k5_;
    DENSE_ELEM(jac_, 1, 0) = I_*k3_;
    DENSE_ELEM(jac_, 1, 1) =  S_*k3_-k4_;
    DENSE_ELEM(jac_, 1, 3) = k2_;
    DENSE_ELEM(jac_, 2, 1) = k4_;
    DENSE_ELEM(jac_, 2, 2) = -k5_;
    DENSE_ELEM(jac_, 3, 0) = k1_;
    DENSE_ELEM(jac_, 3, 3) = -k2_;
    return 0;
    }
